###### R podevt (vce vbr, jeden faktor)######

# POZOR:
# V zkladnm kurzu testujeme pouze vliv jednoho faktoru. 
# ANOVA je v prv ad urena pro vyhdnocovn experiment - pedpokld
# stejn poet men v jednotlivch kombinacch rovn faktor (k se 
# tomu Typ I, model je vyven "wieghted"). Nsledujc vpoty jsou na 
# datech se stejnm potem men, pokud je nemte, tak, aby byly Vae
# vsledky odpovdajc, je teba mt velk poty men v jednotlivch 
# skupinch.

setwd("C:/Users/Navratil/Documents/R")
# setwd("C:/Users/uivatel/Documents/R") # cesta pro koln PC

library(readxl)

data <- read_excel("C:/Users/Navratil/Documents/Navratil/ZF/Statistika/vice_vyberu.xlsx")
# data <- read_excel("E:/R/vice_vyberu.xlsx") # cesta k datm na Vaich flekch

data2 <- as.data.frame(data) # pro nkter pkazy je NUTN mt data.frame!!!!!

data2$poloha <- as.factor(data2$poloha) # pro nkter pkazy je NUTN mt 
# kategoriln prediktory zadan jako faktory!!!!!


####One-way ANOVA####

# Podmnky pouit:
# - nezvisl vbry (= rovn faktoru)
# - data na pomrov stupnici
# - normln rozdlen dat
# - homogenita varianc 

# Vpoet se naume na testovn zvislosti vky rostliny na me oslunn, 
# kter m 3 rovn:

boxplot(vka~poloha, data=data2) # v krabicovm grafu se podvejme na data

# Splnn podmnek?
# - nezvisl vbry mme
# - data jsou na pomrov stupnici
# - je teba otestovat normalitu (dlat cvin nebudeme - nauili jsme se dve)
# - musme otestovat homogenitu varianc



###Levenev test###

# Levenev test je uren k testovn homogenity varianc - tento test v zkladu 
# R nen, je teba naistalovat package - nejobshlej pro een loh ANOVA 
# je package "car"

install.packages("car") # bude to njakou dobu trvat (nkdy dost dlouho)

library(car) # chybovm hlkm nemuste prozatm vnovat pozornost

?leveneTest 

# Zadn je stejn jako u provho t-testu (variant je tady ale vce) 
# a zadv se atribut "center" s hodnotou "mean", poppad "median", 
# pak atribut "data" s hodnotou nzvu tabulky (data.frame)
# kol: Otestujte homogenitu varianc vky rostliny v kategorich polohy rostliny
# H0: varince mezi vbry se neli
# hladina vznamnosti alfa = 95% (= p mus bt men ne 0.05, abych mohl zamtnout H0)

leveneTest(vka~poloha, data=data2, center=mean)

# nebo

leveneTest(data2$vka, data2$poloha, center=mean)

# Vsledek:
#        Df F value Pr(>F)
# group  2  0.766 0.473
#        33   
# H0 nezamtm, rozdl na hladin vznamnosti alfa=95% neexistuje (p je vt ne 0.05)

# Robustnj variantou (= mn nchylnou k poruen pedpoklad testu) 
# je medinov Brown-Forsythe test homogenity varianc - center=median

leveneTest(data2$vka, data2$poloha, center=median)

# Vsledek:
#        Df F value Pr(>F)
# group  2  0.7447 0.4827
#        33   
# H0 nezamtm, rozdl na hladin vznamnosti alfa=95% neexistuje (p je vt ne 0.05)


###Vlastn ANOVA###

# Nejjednodu variantou je pouit vestavn funkce v R pro ANOVA aov()
# POZOR - jejm pedpokladem je pouit pro stejn poty men ve vbrech
# (tzv. Typ I), pokud mte rzn poty, tak muste pout jinou funkci.

?aov

# loha: Otestujte, jestli se li vka rostliny podle toho, zda rostla 
# na slunci, v polostnu nebo ve stnu.
# H0: Prmrn vka rostliny se ve tech vbrech neli
# hladina vznamnosti alfa = 95% (= p mus bt men ne 0.05, abych mohl zamtnout H0)

aov(vka~poloha, data=data2)

# vsledek:
# Sum of Squares  10951.38  42608.41
# Deg. of Freedom        2        33
# Residual standard error: 37.70643
# Estimated effects may be unbalanced

# Mme k dispozici SS a d.f., to toho moc nen, take bude teba si zobrazit
# to, co ns zajm, stejn jako nap. u histogramu si budeme muset
# vsledek nejprve uloit:

anova_vysledek <- aov(vka~poloha, data=data2)

summary(anova_vysledek) # summary() je pkaz k vypsn specifick sti vsledk

# Vsledek:
#            Df Sum Sq Mean Sq F value Pr(>F)
# poloha       2  10951    5476   4.241  0.023 *
# Residuals   33  42608    1291                 
# ---
# Signif. codes:  0 *** 0.001 ** 0.01 * 0.05 . 0.1   1
# H0 zamtm, rozdl na hladin vznamnosti alfa=95% existuje (p je men ne 0.05)
# Chcete-li se dostat k dalm vsledkm sta zadat patin atribut za $, nap.

anova_vysledek$coefficients # vype koeficienty linernho modelu

# Skvl, otestovali jsme, e se prmry li, ovem u nevme jak.
# K identifikaci odlinch prmr slou dal testy, kter se
# oznauj jako post-hoc testy a jejich clem je identifikovat rozdly
# ve vsledcch ANOVA.



###Tukeyho post-hoc test###

# Zkladnm testem pro porovnn prmr je Tukey HSD post-hoc test:

?TukeyHSD

# kol: pokraujeme v pedchozm pklad
# H0slunce-polostn: prmry na slunci a v polostnu se neli
# H0stn-polostn: prmry ve stnu a v polostnu se neli
# H0stn-slunce: prmry ve stnu a na slunci se neli
# vude hladina vznamnosti alfa = 95% (= p mus bt men ne 0.05, abych mohl zamtnout H0)

TukeyHSD(anova_vysledek) # aplikujeme na vsledek ANOVA

# Vsledek:
#                    diff       lwr      upr     p adj
# slunce-polostn -11.15000 -47.14592 24.84592 0.7297260
# stn-polostn    30.14167  -5.85425 66.13758 0.1151664
# stn-slunce      41.29167   5.29575 77.28758 0.0216883
# H0slunce-polostn: nezamtm
# H0stn-polostn: nezamtm
# H0stn-slunce: zamtm

# Pokud chcete graf prmrnch rozdl s 95%  intervaly spolehlivosti,
# tak pouijte pkaz "plot":

plot(TukeyHSD(anova_vysledek)) # jde tedy o graf vsledku TukeyHSD na data
# anova_vysledek, co je datov struktura typu list (seznam)

# Mno a pokud chcete graf s prmry +/- SE a zobrazeny vechny body, tak pouijete 
# funkci ggline v package ggpurbr:

install.packages("ggpubr")

library(ggpubr)

ggline(data, x = "poloha", y = "vka", 
       add = c("mean_se", "jitter"), 
       order = c("slunce", "polostn", "stn"),
       ylab = "vka v cm", xlab = "poloha")

# v add je "mean_se" prmr +/- SE a "jitter" jsou body



###Dunnettv test pro porovnn s kontroln skupinou###

# Pokud mte experimet, tak mte jist kontroln skupinu a clem Vaeho 
# post-hoc testovn nebude porovnn veho se vm, ale porovnn
# vech zsah s kontroln skupinou - k tomu slou Dunnettv test, 
# ten v zkladu R nen a je teba instalovat package - multcomp:

install.packages("multcomp")

library(multcomp)

# Pkaz pro post-hoc testovn je glht(), prvnm atributem je model - v naem
# ppad to je list anova_vysledek, co je vsledek z funkce aov()

?glht

summary(glht(anova_vysledek, linfct=mcp(poloha = "Dunnett")))

# POZOR:
# Jako kontrolu bere pkaz skupinu prvn v abeced (na to je teba myslet pi 
# kdovn) n pklad nen praktick, jen ilustrativn(!!!!!), take se jako 
# kontrola bere "polostn"
# Vsledek:
# Simultaneous Tests for General Linear Hypotheses
# Multiple Comparisons of Means: Dunnett Contrasts
# Fit: aov(formula = vka ~ poloha, data = data)
# Linear Hypotheses:
#                          Estimate Std. Error t value Pr(>|t|)  
# slunce - polostn == 0   -11.15      14.67  -0.760   0.6686  
# stn - polostn == 0      30.14      14.67   2.055   0.0863 .
# ---
#  Signif. codes:  0 *** 0.001 ** 0.01 * 0.05 . 0.1   1
# (Adjusted p values reported -- single-step method)
# ob H0 nemohu zamtnout


###TukeyHSD podruh###

# V package "multcomp" je povcero pkaz a je mezi nimi i pkaz cld
# Vypotejme Tukey HSD test pomoc pkazu glht a ulome jej jako objekt:

tuk1 <- (glht(anova_vysledek, linfct=mcp(poloha = "Tukey")))

# ulome vsledek pkazu cld jako objekt tuk2:

tuk2 <- cld(tuk1)

# vytvome graf z objektu tuk2

plot(tuk2)

# Psmeny jsou zobrazeny tzv. homogenn skupiny, tedy skupiny rovn faktoru,
# kter se na dan hladin vznamnosti neli.



####RMANOVA####

# RMANOVA ja urena pro vbry, kter nejsou nezvisl - nejastji, kdy 
# provedete vce men na jednotlivch objektech.

# kol: Li se meen pH na jae, v asnm lt, pozdnm lt a na podzim?
# H0: men pH se neli
# hladina vznamnosti alfa = 95% (= p mus bt men ne 0.05, abych mohl zamtnout H0)

# Data:
datarm <- read_excel("C:/Users/Navratil/Documents/Navratil/ZF/Statistika/rmanova.xlsx")
# datarm <- read_excel("E:/R/rmanova.xlsx") # cesta k datm na Vaich flekch

# Nejprve stanovme formty

datarm <- as.data.frame(datarm)
datarm$nr <- as.factor(datarm$nr)
datarm$mereni <- as.factor(datarm$mereni)

# daje jsou pod sebou ve sloupci "hodnota", sloupec "mereni" identifijuje 
# poad men (je to 4-rovov faktor, kde jednotliv rovn nejsou 
# nezvisl), a sloupec "nr" identifikuje objekt - POZOR je nutn mt 
# tento identifiktor a mus to bt faktor!!!!!!!

rmanova <- aov(hodnota ~ mereni + Error(nr/mereni), data=datarm)
summary(rmanova)

# pouili jsme opt pkazu aov(), tedy Typ I
# Vsledek:
#Error: nr
#           Df Sum Sq Mean Sq F value Pr(>F)
# Residuals 20  17.36  0.8679               
# Error: nr:men
#            Df Sum Sq Mean Sq F value  Pr(>F)    
# men     3  14.66   4.886   10.27 1.5e-05 ***
# Residuals 60  28.54   0.476                    
#---
#  Signif. codes:  0 *** 0.001 ** 0.01 * 0.05 . 0.1   1
# H0 zamtm nebo p je vrazn men ne 0.05

# POZNMKA: RMANOVA testuje tzv. "within" efekt a zadn je v podstat 
# odpovdajc zadn dvoufaktorov ANOVA, kde interakce nr/mereni je 
# nhodn efekt - vce viz navazujc kurz.

# Problmem je post-hoc - k vsledku aov() si jej muste vypotat v 
# R run. Pokud jej chcete vypotat pkazem, muste pout jin 
# pkaz - my jej pouijeme, ale nebudeme si jej na tomto mst 
# vysvtlovat - opt viz navazujc kurz.

# Budeme potebovat knihovnu "lme4", kter by se mla naistalovat 
# souasn s "car".

library(lme4)

# K vpotu je poteba pout smenho linernho modelu, tentokrt 
# ale nikoliv Typ I, ale Typ III, proto je report vsledku podobn vsledkm 
# z regrese (viz 11. kapitola). Pouije se pkaz lmer pro tvorbu modelu 
# (na msto aov) z pagkage "lme4":

rmanova2 <- lmer(hodnota ~ mereni +(1|nr), data=datarm) 

# (1|nr) je nhodn efekt men na danm objektu, potan podle Typu III

summary(rmanova2) # vsledek modelu

anova(rmanova2) # anova() je pkaz package "car" a dv vsledek ANOVA modelu

# Vsledek je stejn jako v ppad pouit pkazu aov():
# Analysis of Variance Table
#        Df Sum Sq Mean Sq F value
# mereni  3 14.657  4.8858   10.27

# POZOR!!!!!! - stejn nebude, kdy bychom mli "unballanced" data!!!!!!!


###Pos-hoc pro RMANOVA###

# Pro post-hoc testovn pouijeme opt package "multcomp" a pkazu "glht"

# kol: Hledme dvojice v mench pH, ve kterch jsou rozdly
# H0: je jich tolik, kolik je kombinac rovn a H0 zn tak, e dl 
# kombinace se neli
# alfa = 95%, (p mus bt men ne 0,0,5, abychom mohli zamtnout H0)

summary(glht(rmanova2, linfct=mcp(mereni = "Tukey")), test = adjusted(type = "bonferroni"))

# pouili jsme Bonferroniho korekci - jde o RMANOVA a testujeme "within" efekt

# Vsledek:
# Simultaneous Tests for General Linear Hypotheses
# Multiple Comparisons of Means: Tukey Contrasts
# Fit: lmer(formula = hodnota ~ men + (1 | nr), data = datarm)
#Linear Hypotheses:
#                Estimate Std. Error z value Pr(>|z|)    
# pH2 - pH1 == 0   0.5948     0.2129   2.794  0.03122 *  
# pH3 - pH1 == 0   1.1581     0.2129   5.441 3.18e-07 ***
# pH4 - pH1 == 0   0.7748     0.2129   3.640  0.00164 ** 
# pH3 - pH2 == 0   0.5633     0.2129   2.647  0.04879 *  
# pH4 - pH2 == 0   0.1800     0.2129   0.846  1.00000    
# pH4 - pH3 == 0  -0.3833     0.2129  -1.801  0.43030    
# ---
#  Signif. codes:  0 *** 0.001 ** 0.01 * 0.05 . 0.1   1
# (Adjusted p values reported -- bonferroni method)

# Tam, kde jsou hvzdiky, mohu H0 zamtnout




####Kruskal-Wallis test a jeho mnohonsobn porovnn####

# Kruskal-Wallis test je "ANOVA" definovna na ordinlnch datech 
# - hodnot poad a je rozenm Mann-Whitney testu. K-W test je 
# v zkladu R a pkaz je kruskal.test().Test je uren pro posouzen 
# "between" efektu.
# POZOR: data grupovac promnn mus bt seazena abecedn pkazem ordered()

data2$poloha <- ordered(data2$poloha, levels = c("polostn", "slunce", "stn"))

?kruskal.test

# kol: Otestejtuje, jestli se li vka rostliny podle toho, jestli 
# rostla na slunci, v polostnu nebo ve stnu.
# H0: prmrn vka rostliny se ve tech vbrech neli.
# hladina vznamnosti alfa = 95% (= p mus bt men ne 0.05, abych mohl zamtnout H0)

kruskal.test(vka~poloha, data=data2)

# Vsledek:
# Kruskal-Wallis rank sum test
# data:  vka by poloha
# Kruskal-Wallis chi-squared = 8.0826, df = 2, p-value = 0.01757
# H0 zamtm, rozdl na hladin vznamnosti alfa=95% existuje (p je men ne 0.05)

# Pro mnohonsobn porovnn se poije M-W tests s upravenou hodnotou p

pairwise.wilcox.test(data2$vka, data2$poloha, p.adjust.method = "BH")

# Vsledek: 
# 	Pairwise comparisons using Wilcoxon rank sum test 
# data:  data$vka and data$poloha 
#        polostn slunce
# slunce 0.478    -     
# stn   0.103    0.011 
# P value adjustment method: BH 
# Vsledkem je tedy matice v n jsou uvedeny hodnoty p
# V naem ppad rozdly prokzny tmto testem nebyly s vjimkou stn-slunce
# (jen zde H0 na p men ne 0,05 zamtm)

# Dle lze pout pkaz posthoc.kruskal.nemenyi.test(), kter je
# v package PMCMR

install.packages("PMCMR")

library(PMCMR)

posthoc.kruskal.nemenyi.test(data2$vka, data2$poloha)

# Vsledek:
# Pairwise comparisons using Tukey and Kramer (Nemenyi) test	
# with Tukey-Dist approximation for independent samples
# data: data$vka and data$poloha
#        polostn slunce
# slunce 0.682    -     
# stn   0.128    0.015 
# v naem ppad rozdly prokzny tmto testem nebyly s vjimkou stn-slunce 
# (jen zde H0 na p men ne 0,05 zamtm)



#### Friedmanv test a jeho mnohonsobn porovnn####

# Friedmanv test je analogi Wilcoxonova testu pro vce ne 2 vbry a tedy 
# neparametrickou variantou RMANOVA. Pkaz je v zkladu R a zn friedman.test()

?friedman.test

# Pro pkaz jsou hlavn prvn ti parametry: na prvnm mst muste uvst 
# zvislou promnnou, na druhm mst skupinu pri nich chcete testovat "within"
# efekt a nakonec blok, ve kterm bylo men provedeno (= nap. lokalita, 
# kde bylo provedeno opakovn).

# kol: stejn jako u RMANOVA

friedman.test(datarm$hodnota, datarm$mereni, datarm$nr)

# Vsledek:
# Friedman rank sum test
# data:  datarm$hodnota, datarm$mereni and datarm$nr
# Friedman chi-squared = 33.431, df = 3, p-value = 2.613e-07

# K mnohonsobnmu porovnn pouijeme opt package PMCMRplus, tentokrt 
# s pkazem posthoc.friedman.nemenyi.test()

posthoc.friedman.nemenyi.test(datarm$hodnota, datarm$mereni, datarm$nr)

# Vsledky:
# Pairwise comparisons using Nemenyi multiple comparison test	
# with q approximation for unreplicated blocked data
# data: datarm$hodnota , datarm$mereni and datarm$nr
#      pH1     pH2    pH3   
# pH2 0.0789  -      -     
# pH3 8.2e-08 0.0056 -     
# pH4 0.1986  0.9754 0.0012
# P value adjustment method: none
# H0 zamtm, kde je hodnota men ne 0,05